import java.awt.*;
import javax.swing.*;

class Zeichnung extends JPanel {
  // zeichnet modulare Hllkurven

  private int   modul, generator;
  private int[] tabelle;

  public Zeichnung (int m, int b) {
    modul = m; generator = b;
    tabelle = new int[modul + 1];
    } // Ende Konstruktor

  private void vertausche (int[] v, int i, int j)
    {int m = v[i]; v[i] = v[j]; v[j] = m;}

  private int[] Zufallsperm (int n) {
    int[] p = new int[n + 1];
    for (int i = 0; i <= n; i++) p[i] = i;
    for (int k = n - 1; k > 0; k--) {
      int zz = (int) (Math.random() * k);
      vertausche(p, zz, k);
      } // Ende for
    return p;
    } // Ende Zufallsperm

  private int modPot (int a, int n, int m) {
    // berechnet mod(a^n, m) iterativ
    int p = 1;
    while (n > 0) {
      int d = (int) n % 2;
      if (d == 1) p = (p * a) % m;
      a = (a * a) % m;
      n = (n - d) / 2;
      } // Ende while
    return p;
    } // Ende modPot

  private int f (int x)
    {return (generator * x) % modul;}
    
  private int g (int x)
    {return modPot(generator, x, modul);}

  private void dividiere (int n) {
    // dividiert 1 durch n, speichert Reste
    int rest = 1, i = 0;
    do {
      tabelle[i++] = rest;
      int dividend = rest * 10;
      int ziffer = dividend / n;
      rest = dividend % n;
      } while (rest > 1);
    } // Ende dividiere

  private void zeichneKreis (Graphics g, int x0, int y0, int mf) {
    int d = 1; // Dicke des Punkts auf dem Kreis
    double faktor = (double) (2 * Math.PI / modul);
    for (int i = 0; i < modul; i++) {
      double w = (double) i * faktor;
      int x1 = x0 + (int) Math.round(Math.cos(w) * mf);
      int y1 = y0 + (int) Math.round(Math.sin(w) * mf);
      g.fillOval(x1 - d, y1 - d, 2 * d, 2 * d);
      } // Ende for
    } // Ende zeichneKreis

  private void zeichneMuster (Graphics g, int x0, int y0, int mf) {
    double faktor = (double) (2 * Math.PI / modul);
    for (int x = 0; x <= modul; x++) tabelle[x] = g(x);
    // dividiere(modul);
    // tabelle = Zufallsperm(modul);
    int i = 0;
    double w = (double) tabelle[i] * faktor;
    int x1 = x0 + (int) Math.round(Math.cos(w) * mf);
    int y1 = y0 + (int) Math.round(Math.sin(w) * mf);
    while (++i <= modul) {
      w = (double) tabelle[i] * faktor;
      int x2 = x0 + (int) Math.round(Math.cos(w) * mf);
      int y2 = y0 + (int) Math.round(Math.sin(w) * mf);
      // System.out.println(" " + x2 + ", " + y2);
      g.drawLine(x1, y1, x2, y2);
      x1 = x2; y1 = y2;
      } // Ende while
    // g.drawLine(x1, y1, x0, y0);
    } // Ende zeichneKurve
  
  public void paintComponent (Graphics g) {
    super.paintComponent(g);
    zeichneKreis(g, 200, 200, 150);
    zeichneMuster(g, 200, 200, 150);
    } // Ende paintComponent

  } // Ende Zeichnung
